//----------------------------------------------------------------
// GUI main Frame
// Eksempler p swing komponenter
// man kan godt anvende swing sammen med awt Frame m.m. selvom det ikke anbefales
// her anvendes TextArea fra awt, idet det tilsvarende swing
// er noget mere kompliceret at anvende, nr der skal kunne scrolles
// Bemrk Listbox er anderledes end AWT.Choice der arbejdes med objecter
//
// Programmr: Bjrk Busch nov.2001
//----------------------------------------------------------------

import javabook.Convert;
import java.awt.event.*;
import javax.swing.JFrame;
import java.awt.GridLayout;
import java.awt.FlowLayout;
import javax.swing.JPanel;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JComboBox;
import javax.swing.JCheckBox;
import javax.swing.ButtonGroup;
import javax.swing.JRadioButton;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JList;
import java.awt.TextArea;
import java.util.Vector;

public	class GuiMainFrame extends JFrame
{
  // Skrmdata
  private JPanel	  panel1      = new JPanel ();
  private JPanel	  panel1a     = new JPanel ();
  private JPanel	  panel1b     = new JPanel ();
  private JPanel	  panel1c     = new JPanel ();
  private JPanel	  panel1d     = new JPanel ();
  private JPanel	  panel1e     = new JPanel ();
  private JPanel	  panel1f     = new JPanel ();
  private JPanel	  panel2      = new JPanel ();
  private JPanel	  panel3      = new JPanel ();
  private JPanel	  panel4      = new JPanel ();

  private JMenuBar	  menuBar     = new JMenuBar();
  private JMenu 	  menu1       = new JMenu("Popup memu");
  private JMenuItem	  menuItem1   = new JMenuItem("Afls (menuitem)");

  private JComboBox	  combo1      = new JComboBox ();

  private JCheckBox	  check1      = new JCheckBox ("Check 1",false);
  private JCheckBox	  check2      = new JCheckBox ("Check 2",true);

  private ButtonGroup	  group1      = new ButtonGroup ();
  private JRadioButton	  radio1      = new JRadioButton ("Radio 1",false);
  private JRadioButton	  radio2      = new JRadioButton ("Radio 2",true);
  private JRadioButton	  radio3      = new JRadioButton ("Radio 3",false);

  private JLabel	  label1      = new JLabel ("Label1:");
  private JTextField	  tekst1      = new JTextField ("",15);

  private JList 	  listBox1    = new JList(); // 4 linier single valg
  private Vector	  listData1   = new Vector();
  private JList 	  listBox2    = new JList();  // 4 linier multi valg
  private Vector	  listData2   = new Vector();


  private TextArea	  textArea1   = new TextArea ("Events\n",8,25);

  private JButton	  knap1       = new JButton ("Afls (knap1)");




  public GuiMainFrame ()		  /* constructor */
  {
      // opbygning af skrmbillede
      setSize(800,600);
      setTitle("Eksempel p grafiskbrugergrnseflade med swing-komponenter  -	udarbejdet af Bjrk Busch");

      setJMenuBar(menuBar);
      menuBar.add(menu1);
      menu1.add(menuItem1);
      menuItem1.addActionListener(new menuItem1ActionListener());

      //--------------------------------------------------------------------
      // opdeling af skrm i paneler

      getContentPane().setLayout(new GridLayout(2,2));		      // bemrk getContentPane().  foran ved SWING JFrame

      panel1.setBorder(new TitledBorder(new EtchedBorder(),"Panel1-gruppe"));
      panel1.setLayout(new GridLayout(3,2));
      getContentPane().add(panel1);	      // bemrk getContentPane().  foran ved SWING JFrame

      panel1a.setBorder(new TitledBorder(new EtchedBorder(),"SubPanel a"));
      panel1a.setLayout(new GridLayout(1,1));
      panel1.add(panel1a);

      panel1b.setBorder(new TitledBorder(new EtchedBorder(),"SubPanel b"));
      panel1b.setLayout(new GridLayout(1,2));
      panel1.add(panel1b);

      panel1c.setBorder(new TitledBorder(new EtchedBorder(),"SubPanel c"));
      panel1c.setLayout(new GridLayout(2,1));
      panel1.add(panel1c);

      panel1d.setBorder(new TitledBorder(new EtchedBorder(),"SubPanel d"));
      panel1d.setLayout(new GridLayout(1,1));
      panel1.add(panel1d);

      panel1e.setBorder(new TitledBorder(new EtchedBorder(),"SubPanel e"));
      panel1e.setLayout(new FlowLayout());
      panel1.add(panel1e);

      panel1f.setBorder(new TitledBorder(new EtchedBorder(),"SubPanel f"));
      panel1f.setLayout(new FlowLayout());
      panel1.add(panel1f);


      panel2.setBorder(new TitledBorder(new EtchedBorder(),"Panel2-gruppe"));
      panel2.setLayout(new GridLayout(1,1));
      getContentPane().add(panel2);	      // bemrk getContentPane().  foran ved SWING JFrame

      panel3.setBorder(new TitledBorder(new EtchedBorder(),"Panel3-gruppe"));
      panel3.setLayout(new GridLayout(1,2));
      getContentPane().add(panel3);	      // bemrk getContentPane().  foran ved SWING JFrame


      panel4.setBorder(new TitledBorder(new EtchedBorder(),"Panel4-gruppe"));
      panel4.setLayout(new GridLayout(1,1));
      getContentPane().add(panel4);	      // bemrk getContentPane().  foran ved SWING JFrame

      //--------------------------------------------------------------------
      // De "egentlige" skrmelementer tildeles vrdier og pladseres p skrmen

      combo1.addItem("Valg 1");
      combo1.addItem("Valg 2");
      combo1.addItem("Valg 3");
      combo1.setEditable(true);
      panel1a.add(combo1);

      panel1b.add(check1);
      panel1b.add(check2);

      group1.add(radio1);
      group1.add(radio2);
      group1.add(radio3);
      panel1c.add(radio1);
      panel1c.add(radio2);
      panel1d.add(radio3);


      panel1e.add(label1);

      tekst1.setText("indhold i tekst");
      panel1f.add(tekst1);

      listData1.add("singlevalgbox: 1. elm");
      listData1.add("singlevalgbox: 2. elm");
      listData1.add("singlevalgbox: 3. elm");
      listData1.add("singlevalgbox: 4. elm");
      listData1.add("singlevalgbox: 5. elm");
      listData1.add("singlevalgbox: 6. elm");
      listBox1.setListData(listData1);
      listBox1.setSelectionMode(1);	      // 1=SINGLE_SELECTION
									      // 0=MULTIPLE_SELECTION
									      // 1=SINGLE_SELECTION
									      // 2=SINGLE_INTERVAL_SELECTION
									      // 3=MULTIPLE_INTERVAL_SELECTION
      listBox1.setSelectedIndex(1);	      // "default" valg er 2. element
      panel3.add(listBox1);

      listData2.add("multivalgbox med ctrl: 1. elm");
      listData2.add("multivalgbox med ctrl: 2. elm");
      listData2.add("multivalgbox med ctrl: 3. elm");
      listData2.add("multivalgbox med ctrl: 4. elm");
      listData2.add("multivalgbox med ctrl: 5. elm");
      listData2.add(new Person("Ib",27));     // et object, som ikke er en String
      listBox2.setListData(listData2);
      listBox1.setSelectionMode(1);	      // 0=MULTIPLE_SELECTION
      listBox2.setSelectedIndex(1);	      // "default" valg er 2. element
      panel3.add(listBox2);

      textArea1.setEditable(false);
      panel2.add(textArea1);

      panel4.add(knap1);
      knap1.addActionListener(new knap1ActionListener());
  }

  private void Aflaesning()
  {
      textArea1.append("Knap1 aktiveret\n");

      textArea1.append("Aflsninger:\n");

      textArea1.append("combo1: "+(String)combo1.getSelectedItem()+"\n");

      if (radio1.isSelected())
	      textArea1.append("Radio 1 ON\n");
      else
	      textArea1.append("Radio 1 OFF\n");

      if (radio2.isSelected())
	      textArea1.append("Radio 2 ON\n");
      else
	      textArea1.append("Radio 2 OFF\n");

      if (radio3.isSelected())
	      textArea1.append("Radio 3 ON\n");
      else
	      textArea1.append("Radio 3 OFF\n");

      if (check1.isSelected())
	      textArea1.append("Check 1 ON\n");
      else
	      textArea1.append("Check 1 OFF\n");

      if (check2.isSelected())
	      textArea1.append("Check 2 ON\n");
      else
	      textArea1.append("Check 2 OFF\n");

      textArea1.append("Tekst1 "+tekst1.getText()+"\n");

      textArea1.append("listbox1 valg index: "+listBox1.getSelectedIndex()+"\n");
      textArea1.append("listbox1 valg item: "+listBox1.getSelectedValue()+"\n");

      textArea1.append("listbox2 multivalg:\n");
      int []  valg2indexes = listBox2.getSelectedIndices();
      for (int i = 0; i < valg2indexes.length; i++ )
	      textArea1.append("listbox2 valg index: "+valg2indexes[i]+"\n");

      Object []       valg2Items = listBox2.getSelectedValues();
      for (int i = 0; i < valg2Items.length; i++ )
	      textArea1.append("listbox2 valg: "+valg2Items[i]+"\n");
      for (int i = 0; i < valg2Items.length; i++ )
	      if (valg2Items[i] instanceof Person)
		      textArea1.append("listbox2 valg er en Person\n");

      textArea1.append("------------------------------\n");
  }

  private class knap1ActionListener implements java.awt.event.ActionListener
  {
    public void actionPerformed(ActionEvent e)
    {
      textArea1.append("Knap1 aktiveret\n");
      Aflaesning();
    }
  }

  private class menuItem1ActionListener implements java.awt.event.ActionListener
  {
    public void actionPerformed(ActionEvent e)
    {
      textArea1.append("menuItem1 aktiveret\n");
      Aflaesning();
    }
  }

} // slut p frame-klasse
